Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.MetaOptimization.Test/Program.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.MetaOptimization.Test/Program.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.MetaOptimization.Test/Program.cs	(revision 5653)
@@ -2,8 +2,11 @@
 using System.Collections;
 using System.Collections.Generic;
+using System.Diagnostics;
 using System.IO;
 using System.Linq;
+using System.Reflection;
 using System.Text;
 using System.Threading;
+using System.Threading.Tasks;
 using HeuristicLab.Algorithms.EvolutionStrategy;
 using HeuristicLab.Algorithms.GeneticAlgorithm;
@@ -11,18 +14,13 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Hive.ExperimentManager;
 using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
 using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.PluginInfrastructure.Manager;
 using HeuristicLab.Problems.MetaOptimization;
 using HeuristicLab.Problems.TestFunctions;
 using HeuristicLab.Random;
 using HeuristicLab.Selection;
-using HeuristicLab.Parameters;
-using HeuristicLab.Operators;
-using System.Diagnostics;
-using HeuristicLab.Encodings.RealVectorEncoding;
-using HeuristicLab.Hive.ExperimentManager;
-using System.Threading.Tasks;
-using HeuristicLab.PluginInfrastructure.Manager;
-using System.Reflection;
 
 namespace HeuristicLab.MetaOptimization.Test {
@@ -70,5 +68,5 @@
       //TestEnumeratorCollectionEnumerator();
       //TestCombinations4(); return;
-      //TestAlgorithmPerformanceIssue();
+      //TestAlgorithmPerformanceIssue(); return;
       //TestWaitAny();
       //TestExecutionTimeUpdateInvervalPerformance();
@@ -76,7 +74,5 @@
       //TestNormalCrossover();
       //TestItemDictionary();
-
-
-
+      
       MetaOptimizationProblem metaOptimizationProblem = new MetaOptimizationProblem();
       metaOptimizationProblem.Repetitions = new IntValue(metaProblemRepetitions);
@@ -87,5 +83,5 @@
       //EvolutionStrategy metaLevelAlgorithm = GetMetaES(metaOptimizationProblem);
 
-      IValueConfiguration algorithmVc = SetupGAAlgorithm(typeof(GeneticAlgorithm), metaOptimizationProblem);
+      var algorithmVc = SetupGAAlgorithm(typeof(GeneticAlgorithm), metaOptimizationProblem);
 
       //TestToString(algorithmVc);
@@ -94,5 +90,5 @@
       //Console.WriteLine("Press enter to start");
       //Console.ReadLine();
-      //TestConfiguration(algorithmVc, baseLevelAlgorithm);
+      //TestConfiguration(algorithmVc, new GeneticAlgorithm());
 
       //Console.WriteLine("Press enter to start");
@@ -140,5 +136,5 @@
       vc1.ParameterConfigurations.Single(x => x.Name == "Selector").Optimize = true;
 
-      var vc2 = (IValueConfiguration)vc1.Clone();
+      var vc2 = (ParameterConfigurationTree)vc1.Clone();
       Console.WriteLine("Assert(1): {0}", vc1.CalculateSimilarity(vc2));
 
@@ -289,6 +285,5 @@
           swx.Start();
           ((EngineAlgorithm)alg).ExecutionTimeChanged += new EventHandler(Program_ExecutionTimeChanged);
-          var executor = new AlgorithmExecutor((EngineAlgorithm)alg);
-          executor.StartSync();
+          ((EngineAlgorithm)alg).StartSync();
           ((EngineAlgorithm)alg).ExecutionTimeChanged -= new EventHandler(Program_ExecutionTimeChanged);
           swx.Stop();
@@ -369,4 +364,5 @@
       Queue<TimeSpan> latestExecutionTimes = new Queue<TimeSpan>();
       int size = 10;
+      var random = new Random.MersenneTwister(0);
 
       GeneticAlgorithm ga = new GeneticAlgorithm();
@@ -374,20 +370,32 @@
       ga.MaximumGenerations.Value = 1;
       ga.Engine = new SequentialEngine.SequentialEngine();
-      throw new NotImplementedException("TODO: Set ga parameters correctly");
+      ga.Problem = new SingleObjectiveTestFunctionProblem();
 
       MetaOptimizationProblem metaOptimizationProblem = new MetaOptimizationProblem();
-      metaOptimizationProblem.Repetitions = new IntValue(metaProblemRepetitions);
+      //metaOptimizationProblem.Repetitions = new IntValue(metaProblemRepetitions);
       GeneticAlgorithm metaLevelAlgorithm = GetMetaGA(metaOptimizationProblem);
       ParameterConfigurationTree algorithmVc = SetupGAAlgorithm(typeof(GeneticAlgorithm), metaOptimizationProblem);
+      algorithmVc.Randomize(random);
       Stopwatch sw = new Stopwatch();
 
+      var algs = new Queue<IAlgorithm>(); // keep them in memory 
+      // -> BINGO! -> .NET cannot hold more than 16 algorithms with their ThreadLocal<T> objects efficiently, 
+      // so if they are kept in memory, runtime at the 17. execution drops significantly
+      // because creating ThreadLocal<T> takes all the runtime.
+      // when the algs are not stored in a list however this effect does not occur.
+      
+
       for (int i = 0; i < 1000; i++) {
-        sw.Start();
         GeneticAlgorithm clonedGa = (GeneticAlgorithm)ga.Clone();
         clonedGa.Name = "CLONED GA";
-        algorithmVc.Parameterize(clonedGa);
+        //algorithmVc.Randomize(random);
+        //algorithmVc.Parameterize(clonedGa);
         clonedGa.Prepare(true);
-        var executor = new AlgorithmExecutor(clonedGa);
-        executor.StartSync();
+        sw.Start();
+        algs.Enqueue(clonedGa);
+
+        if (algs.Count > 24)
+          algs.Dequeue();
+        clonedGa.StartSync();
         sw.Stop();
         latestExecutionTimes.Enqueue(sw.Elapsed);
@@ -549,5 +557,5 @@
     private static void TestTypeDiscovery() {
       PluginLoader.pluginAssemblies.Any();
-
+      
       var items = ApplicationManager.Manager.GetInstances(typeof(DoubleArray)).ToArray();
 
@@ -634,30 +642,31 @@
       ((IntValue)algorithmVc.ParameterConfigurations.Single(x => x.Name == "MaximumGenerations").ActualValue.Value).Value = baseAlgorithmMaxGenerations;
 
+      metaOptimizationProblem.Problems.Clear();
       metaOptimizationProblem.Problems.Add(new HeuristicLab.Problems.TestFunctions.SingleObjectiveTestFunctionProblem() {
         Evaluator = new GriewankEvaluator(),
         ProblemSize = new IntValue(2)
       });
-      metaOptimizationProblem.Problems.Add(new HeuristicLab.Problems.TestFunctions.SingleObjectiveTestFunctionProblem() {
-        Evaluator = new GriewankEvaluator(),
-        ProblemSize = new IntValue(20)
-      });
-      metaOptimizationProblem.Problems.Add(new HeuristicLab.Problems.TestFunctions.SingleObjectiveTestFunctionProblem() {
-        Evaluator = new GriewankEvaluator(),
-        ProblemSize = new IntValue(500)
-      });
-
-      ConfigurePopulationSize(algorithmVc, 5, 20, 1);
-      ConfigureMutationRate(algorithmVc, 0.0, 1.0, 0.01);
+      //metaOptimizationProblem.Problems.Add(new HeuristicLab.Problems.TestFunctions.SingleObjectiveTestFunctionProblem() {
+      //  Evaluator = new GriewankEvaluator(),
+      //  ProblemSize = new IntValue(20)
+      //});
+      //metaOptimizationProblem.Problems.Add(new HeuristicLab.Problems.TestFunctions.SingleObjectiveTestFunctionProblem() {
+      //  Evaluator = new GriewankEvaluator(),
+      //  ProblemSize = new IntValue(500)
+      //});
+
+      //ConfigurePopulationSize(algorithmVc, 15, 20, 1);
+      //ConfigureMutationRate(algorithmVc, 0.0, 1.0, 0.01);
       ConfigureMutationOperator(algorithmVc);
-      //ConfigureElites(algorithmVc, 0, 30, 1);
-      ConfigureSelectionOperator(algorithmVc, true);
+      //ConfigureElites(algorithmVc, 0, 8, 1);
+      //ConfigureSelectionOperator(algorithmVc, true);
       return algorithmVc;
     }
 
-    private static void TestConfiguration(IValueConfiguration algorithmVc, GeneticAlgorithm baseLevelAlgorithm) {
+    private static void TestConfiguration(ParameterConfigurationTree algorithmVc, GeneticAlgorithm baseLevelAlgorithm) {
       IRandom rand = new FastRandom(0);
       // set random values
       for (int i = 0; i < 10; i++) {
-        IValueConfiguration clonedVc = (IValueConfiguration)algorithmVc.Clone();
+        var clonedVc = (ParameterConfigurationTree)algorithmVc.Clone();
         GeneticAlgorithm newAlg = (GeneticAlgorithm)baseLevelAlgorithm.Clone();
         clonedVc.Randomize(rand);
@@ -676,5 +685,5 @@
       // mutate
       for (int i = 0; i < 10; i++) {
-        IValueConfiguration clonedVc = (IValueConfiguration)algorithmVc.Clone();
+        var clonedVc = (ParameterConfigurationTree)algorithmVc.Clone();
         GeneticAlgorithm newAlg = (GeneticAlgorithm)baseLevelAlgorithm.Clone();
         ParameterConfigurationManipulator.Apply(rand, clonedVc, new UniformIntValueManipulator(), new NormalDoubleValueManipulator());
@@ -692,6 +701,6 @@
       // cross
       for (int i = 0; i < 10; i++) {
-        IValueConfiguration clonedVc1 = (IValueConfiguration)algorithmVc.Clone();
-        IValueConfiguration clonedVc2 = (IValueConfiguration)algorithmVc.Clone();
+        var clonedVc1 = (ParameterConfigurationTree)algorithmVc.Clone();
+        var clonedVc2 = (ParameterConfigurationTree)algorithmVc.Clone();
 
         GeneticAlgorithm first = (GeneticAlgorithm)baseLevelAlgorithm.Clone();
@@ -725,5 +734,5 @@
     }
 
-    private static void ConfigureMutationOperator(IValueConfiguration algorithmVc) {
+    private static void ConfigureMutationOperator(ParameterConfigurationTree algorithmVc) {
       var mutationOperator = algorithmVc.ParameterConfigurations.Where(x => x.Name == "Mutator").SingleOrDefault();
       mutationOperator.Optimize = true;
@@ -735,9 +744,9 @@
       }
 
-      // add another normal
-      mutationOperator.ValueConfigurations.Add(new ValueConfiguration(new NormalAllPositionsManipulator(), typeof(NormalAllPositionsManipulator)), true);
-    }
-
-    private static void ConfigureSelectionOperator(IValueConfiguration algorithmVc, bool configureTournamenSize) {
+      // add another normal - don't do this with 'new', because ActualNames will not be set correctly. It should be copied from an existing one
+      // mutationOperator.ValueConfigurations.Add(new ParameterizedValueConfiguration(new NormalAllPositionsManipulator(), typeof(NormalAllPositionsManipulator)), true);
+    }
+
+    private static void ConfigureSelectionOperator(ParameterConfigurationTree algorithmVc, bool configureTournamenSize) {
       var selectionOperatorPc = algorithmVc.ParameterConfigurations.Where(x => x.Name == "Selector").SingleOrDefault();
       selectionOperatorPc.Optimize = true;
@@ -748,5 +757,5 @@
           if (configureTournamenSize) {
             vc.Optimize = true;
-            ConfigureTournamentGroupSize(vc);
+            ConfigureTournamentGroupSize((ParameterizedValueConfiguration)vc);
           }
         } else if (vc.ActualValue.ValueDataType == typeof(RandomSelector)) {
@@ -758,18 +767,18 @@
     }
 
-    private static void ConfigureTournamentGroupSize(IValueConfiguration tournamentVc) {
+    private static void ConfigureTournamentGroupSize(ParameterizedValueConfiguration tournamentVc) {
       var groupSizePc = tournamentVc.ParameterConfigurations.Where(x => x.ParameterName == "GroupSize").SingleOrDefault();
       groupSizePc.Optimize = true;
-
-      groupSizePc.ValueConfigurations.First().Optimize = true;
-      groupSizePc.ValueConfigurations.First().RangeConstraint.LowerBound = new IntValue(0);
-      groupSizePc.ValueConfigurations.First().RangeConstraint.UpperBound = new IntValue(10);
-      groupSizePc.ValueConfigurations.First().RangeConstraint.StepSize = new IntValue(1);
-    }
-
-    private static void ConfigurePopulationSize(IValueConfiguration algorithmVc, int lower, int upper, int stepsize) {
+      var groupSizeVc = (RangeValueConfiguration)groupSizePc.ValueConfigurations.First();
+      groupSizeVc.Optimize = true;
+      groupSizeVc.RangeConstraint.LowerBound = new IntValue(0);
+      groupSizeVc.RangeConstraint.UpperBound = new IntValue(10);
+      groupSizeVc.RangeConstraint.StepSize = new IntValue(1);
+    }
+
+    private static void ConfigurePopulationSize(ParameterizedValueConfiguration algorithmVc, int lower, int upper, int stepsize) {
       var populationSizePc = algorithmVc.ParameterConfigurations.Where(x => x.Name == "PopulationSize").SingleOrDefault();
       populationSizePc.Optimize = true;
-      var populationSizeVc = populationSizePc.ValueConfigurations.First();
+      var populationSizeVc = (RangeValueConfiguration)populationSizePc.ValueConfigurations.First();
       populationSizeVc.Optimize = true;
       populationSizeVc.RangeConstraint.LowerBound = new IntValue(lower);
@@ -778,8 +787,8 @@
     }
 
-    private static void ConfigureMutationRate(IValueConfiguration algorithmVc, double lower, double upper, double stepsize) {
+    private static void ConfigureMutationRate(ParameterizedValueConfiguration algorithmVc, double lower, double upper, double stepsize) {
       var mutationRatePc = algorithmVc.ParameterConfigurations.Where(x => x.Name == "MutationProbability").SingleOrDefault();
       mutationRatePc.Optimize = true;
-      var mutationRateVc = mutationRatePc.ValueConfigurations.First();
+      var mutationRateVc = (RangeValueConfiguration)mutationRatePc.ValueConfigurations.First();
       mutationRateVc.Optimize = true;
       mutationRateVc.RangeConstraint.LowerBound = new PercentValue(lower);
@@ -788,8 +797,8 @@
     }
 
-    private static void ConfigureElites(IValueConfiguration algorithmVc, int from, int to, int stepSize) {
+    private static void ConfigureElites(ParameterizedValueConfiguration algorithmVc, int from, int to, int stepSize) {
       var elitesPc = algorithmVc.ParameterConfigurations.Where(x => x.Name == "Elites").SingleOrDefault();
       elitesPc.Optimize = true;
-      var elitesVc = elitesPc.ValueConfigurations.First();
+      var elitesVc = (RangeValueConfiguration)elitesPc.ValueConfigurations.First();
       elitesVc.Optimize = true;
       elitesVc.RangeConstraint.LowerBound = new IntValue(from);
@@ -855,22 +864,23 @@
                 var orderedRuns = rc.OrderBy(x => x.Results["AverageQualityNormalized"]);
 
-                TableBuilder tb = new TableBuilder("QNorm", "Qualities", "PoSi", "MutRa", /*"Eli",*/ "SelOp", "MutOp", "NrSelSubScopes");
+                TableBuilder tb = new TableBuilder("QNorm", "Qualities"/*, "PoSi"/* "MutRa", "Eli", "SelOp", "MutOp", "NrSelSubScopes"*/);
                 foreach (IRun run in orderedRuns) {
-                  string selector;
-                  if (run.Parameters["Selector"] is TournamentSelector) {
-                    selector = string.Format("{0} ({1})", run.Parameters["Selector"].ToString(), ((TournamentSelector)run.Parameters["Selector"]).GroupSizeParameter.Value.ToString());
-                  } else {
-                    selector = string.Format("{0}", run.Parameters["Selector"].ToString());
-                  }
+                  //string selector;
+                  //if (run.Parameters["Selector"] is TournamentSelector) {
+                  //  selector = string.Format("{0} ({1})", run.Parameters["Selector"].ToString(), ((TournamentSelector)run.Parameters["Selector"]).GroupSizeParameter.Value.ToString());
+                  //} else {
+                  //  selector = string.Format("{0}", run.Parameters["Selector"].ToString());
+                  //}
 
                   tb.AppendRow(
                     ((DoubleValue)run.Results["AverageQualityNormalized"]).Value.ToString("#0.0000"),
-                    ((DoubleArray)run.Results["RunsAverageQualities"]).ToString(),
-                    ((IntValue)run.Parameters["PopulationSize"]).Value.ToString(),
-                    ((DoubleValue)run.Parameters["MutationProbability"]).Value.ToString("0.0000"),
+                    ((DoubleArray)run.Results["RunsAverageQualities"]).ToString()
+                    //((IntValue)run.Parameters["PopulationSize"]).Value.ToString(),
+                    //((DoubleValue)run.Parameters["MutationProbability"]).Value.ToString("0.0000"),
                     //((IntValue)run.Parameters["Elites"]).Value.ToString(),
-                    Shorten(selector, 20),
-                    Shorten(run.Parameters.ContainsKey("Mutator") ? run.Parameters["Mutator"].ToString() : "null", 40),
-                    ((ISelector)run.Parameters["Selector"]).NumberOfSelectedSubScopesParameter.Value.ToString());
+                    //Shorten(selector, 20),
+                    //Shorten(run.Parameters.ContainsKey("Mutator") ? run.Parameters["Mutator"].ToString() : "null", 40),
+                    //((ISelector)run.Parameters["Selector"]).NumberOfSelectedSubScopesParameter.Value.ToString()
+                    );
                 }
                 sb.AppendLine(tb.ToString());
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.MetaOptimization.sln
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.MetaOptimization.sln	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.MetaOptimization.sln	(revision 5653)
@@ -10,5 +10,4 @@
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{F96C8DD1-9B68-4F2D-AD4F-1A174F596041}"
 	ProjectSection(SolutionItems) = preProject
-		Performance1.psess = Performance1.psess
 		PreBuildEvent.cmd = PreBuildEvent.cmd
 	EndProjectSection
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization.Views/3.3/OptimizableView.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization.Views/3.3/OptimizableView.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization.Views/3.3/OptimizableView.cs	(revision 5653)
@@ -1,14 +1,6 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Linq;
-using System.Text;
 using HeuristicLab.Core.Views;
+using HeuristicLab.Data;
 using HeuristicLab.MainForm;
-using HeuristicLab.Parameters;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
 
 namespace HeuristicLab.Problems.MetaOptimization.Views.ValueConfigurationViews {
@@ -47,17 +39,27 @@
         if (Content.Optimize) {
           this.viewHost.ViewType = null;
-          if (Content is IParameterConfiguration) {
+
+          var pc = Content as IParameterConfiguration;
+          var vc = Content as IValueConfiguration;
+
+          if (pc != null) {
             this.viewHost.Content = ((IParameterConfiguration)Content).ValueConfigurations;
-          } else if (Content is IValueConfiguration) {
-            if (Content.ActualValue.ValueDataType == typeof(IntValue) ||
+          } else if(vc != null) {
+            var rvc = Content as RangeValueConfiguration;
+            if (rvc != null) {
+              if (Content.ActualValue.ValueDataType == typeof(IntValue) ||
                 Content.ActualValue.ValueDataType == typeof(DoubleValue) ||
                 Content.ActualValue.ValueDataType == typeof(PercentValue)) {
-              this.viewHost.ViewsLabelVisible = true;
-              this.viewHost.Content = ((IValueConfiguration)Content).RangeConstraint;
-            } else if(Content.ActualValue.ValueDataType == typeof(BoolValue)) {
-              this.viewHost.Content = null; // no configuration required
-            } else {
+                this.viewHost.ViewsLabelVisible = true;
+                this.viewHost.Content = rvc.RangeConstraint;
+              } else if (Content.ActualValue.ValueDataType == typeof(BoolValue)) {
+                this.viewHost.Content = null; // no configuration required
+              }
+            }
+
+            var pvc = Content as ParameterizedValueConfiguration;
+            if (pvc != null) {
               this.viewHost.ViewsLabelVisible = false;
-              this.viewHost.Content = ((IValueConfiguration)Content).ParameterConfigurations;
+              this.viewHost.Content = pvc.ParameterConfigurations;
             }
           } else {
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization.Views/3.3/ValueConfigurationViews/ValueConfigurationCheckedItemList.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization.Views/3.3/ValueConfigurationViews/ValueConfigurationCheckedItemList.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization.Views/3.3/ValueConfigurationViews/ValueConfigurationCheckedItemList.cs	(revision 5653)
@@ -1,15 +1,10 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
 using System.Linq;
-using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
 using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
-using HeuristicLab.Core;
-using System.Windows.Forms;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Collections;
 
 namespace HeuristicLab.Problems.MetaOptimization.Views {
@@ -76,7 +71,9 @@
           if (value is NullValue) {
             return new NullValueConfiguration();
+          } else if(value is IParameterizedItem) {
+            return new ParameterizedValueConfiguration(value, value.GetType());
           } else {
-            return new ValueConfiguration(value, value.GetType());
-          }
+            return new RangeValueConfiguration(value, value.GetType());
+          } 
         }
         catch (Exception ex) {
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/AlgorithmExecutor.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/AlgorithmExecutor.cs	(revision 5653)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/AlgorithmExecutor.cs	(revision 5653)
@@ -0,0 +1,43 @@
+﻿using System;
+using System.Threading;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+
+  public static class AlgorithmExtensions {
+    public static void StartSync(this IAlgorithm algorithm) {
+      var executor = new AlgorithmExecutor(algorithm);
+      executor.StartSync();
+    }
+  }
+
+  /// <summary>
+  /// Can execute an algorithm synchronously
+  /// </summary>
+  internal class AlgorithmExecutor {
+    private IAlgorithm algorithm;
+    private AutoResetEvent waitHandle = new AutoResetEvent(false);
+
+    public AlgorithmExecutor(IAlgorithm algorithm) {
+      this.algorithm = algorithm;
+    }
+
+    public void StartSync() {
+      algorithm.Stopped += new EventHandler(algorithm_Stopped);
+      algorithm.Paused += new EventHandler(algorithm_Paused);
+      algorithm.Start();
+      waitHandle.WaitOne();
+      waitHandle.Dispose();
+      algorithm.Stopped -= new EventHandler(algorithm_Stopped);
+      algorithm.Paused -= new EventHandler(algorithm_Paused);
+    }
+
+    void algorithm_Paused(object sender, EventArgs e) {
+      waitHandle.Set();
+    }
+
+    void algorithm_Stopped(object sender, EventArgs e) {
+      waitHandle.Set();
+    }
+  }
+}
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/ReferenceQualityAnalyzer.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/ReferenceQualityAnalyzer.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/ReferenceQualityAnalyzer.cs	(revision 5653)
@@ -68,5 +68,5 @@
       DoubleArray referenceQualities = new DoubleArray(ProblemsParameter.ActualValue.Count);
       for (int pi = 0; pi < ProblemsParameter.ActualValue.Count; pi++) {
-        referenceQualities[pi] = solutions.Select(x => x.AverageQualities[pi]).Min(); // todo: respect minimization / maximization
+        referenceQualities[pi] = solutions.Where(x => x.AverageQualities != null).Select(x => x.AverageQualities[pi]).Min(); // todo: respect minimization / maximization
       }
       return referenceQualities;
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/Crossovers/ParameterConfigurationCrossover.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/Crossovers/ParameterConfigurationCrossover.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/Crossovers/ParameterConfigurationCrossover.cs	(revision 5653)
@@ -97,5 +97,5 @@
 
     private static void Cross(IRandom random, IOptimizable configuartion, IOptimizable other, IIntValueCrossover intValueCrossover, IDoubleValueCrossover doubleValueCrossover) {
-      var vc = configuartion as IValueConfiguration;
+      var vc = configuartion as RangeValueConfiguration;
       var pc = configuartion as IParameterConfiguration;
       if (vc != null) {
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/Manipulators/ParameterConfigurationManipulator.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/Manipulators/ParameterConfigurationManipulator.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/Manipulators/ParameterConfigurationManipulator.cs	(revision 5653)
@@ -1,13 +1,10 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+﻿using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
-using HeuristicLab.Core;
 using HeuristicLab.Parameters;
-using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Data;
 
 namespace HeuristicLab.Problems.MetaOptimization {
@@ -55,5 +52,5 @@
 
     protected static void Mutate(IRandom random, IOptimizable configuration, IIntValueManipulator intValueManipulator, IDoubleValueManipulator doubleValueManipulator) {
-      var vc = configuration as IValueConfiguration;
+      var vc = configuration as RangeValueConfiguration;
       var pc = configuration as IParameterConfiguration;
 
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/ParameterCombinationsEnumerator.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/ParameterCombinationsEnumerator.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/ParameterCombinationsEnumerator.cs	(revision 5653)
@@ -1,7 +1,5 @@
 ﻿using System;
+using System.Collections;
 using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Collections;
 using HeuristicLab.Core;
 
@@ -25,5 +23,5 @@
         if (!initialized)
           throw new SystemException("Enumeration not started. Call MoveNext!");
-        return Current; 
+        return Current;
       }
     }
@@ -94,21 +92,22 @@
       }
 
-      var vc = node as IValueConfiguration;
-      if (vc != null) {
-        if (vc.RangeConstraint != null) {
-          valueEnumerator = new EnumeratorCollectionEnumerator<IItem>();
-          valueEnumerator.AddEnumerator(vc.RangeConstraint.GetCombinations().GetEnumerator());
-          valueEnumerator.Reset();
-          enumerators.Add(valueEnumerator);
-        } else {
-          foreach (var parameterConfiguration in vc.ParameterConfigurations) {
-            if (parameterConfiguration.Optimize) {
-              var enumerator = new ParameterCombinationsEnumerator(parameterConfiguration);
-              enumerator.Reset();
-              enumerators.Add(enumerator);
-            }
+      var rangeVc = node as RangeValueConfiguration;
+      if (rangeVc != null) {
+        valueEnumerator = new EnumeratorCollectionEnumerator<IItem>();
+        valueEnumerator.AddEnumerator(rangeVc.RangeConstraint.GetCombinations().GetEnumerator());
+        valueEnumerator.Reset();
+        enumerators.Add(valueEnumerator);
+      }
+
+      var parameterizedVc = node as ParameterizedValueConfiguration;
+      if (parameterizedVc != null) {
+        foreach (var parameterConfiguration in parameterizedVc.ParameterConfigurations) {
+          if (parameterConfiguration.Optimize) {
+            var enumerator = new ParameterCombinationsEnumerator(parameterConfiguration);
+            enumerator.Reset();
+            enumerators.Add(enumerator);
           }
-          enumerators.Reverse(); // this makes the list of combinations better readable
         }
+        enumerators.Reverse(); // this makes the list of combinations better readable
       }
     }
@@ -129,5 +128,5 @@
     }
 
-    public void Dispose() {  }
+    public void Dispose() { }
 
     public T Current {
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/ParameterConfigurationTree.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/ParameterConfigurationTree.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Encoding/ParameterConfigurationTree.cs	(revision 5653)
@@ -1,17 +1,15 @@
 ﻿using System;
+using System.Collections;
 using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Common;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Optimization;
-using HeuristicLab.Data;
-using System.Collections;
 
 namespace HeuristicLab.Problems.MetaOptimization {
   // todo: storable, name, descr, ...
   [StorableClass]
-  public class ParameterConfigurationTree : ValueConfiguration, IEnumerable {
+  public class ParameterConfigurationTree : ParameterizedValueConfiguration, IEnumerable {
 
     [Storable]
@@ -189,5 +187,5 @@
     public Experiment GenerateExperiment(IAlgorithm algorithm, bool createBatchRuns, int repetitions) {
       Experiment experiment = new Experiment();
-      foreach (IValueConfiguration combination in this) {
+      foreach (ParameterizedValueConfiguration combination in this) {
         IAlgorithm clonedAlg = (IAlgorithm)algorithm.Clone();
         clonedAlg.Name = combination.ParameterInfoString;
